## libvncserver 0.9.11+dfsg-1.3.3

=== debian/changelog ===
libvncserver (0.9.11+dfsg-1.3.3-deepin1) buster; urgency=medium

  * debian/patches: Add CVE patches cve-2020-14401, cve-2020-14402

 -- luxinyou <luxinyou@uniontech.com>  Wed, 14 Dec 2022 14:05:51 +0100

libvncserver (0.9.11+dfsg-1.3.2-deepin1) buster; urgency=medium

  * debian/patches: Add CVE patches cve-2019-20788, cve-2019-20839,
    cve-2020-14405, cve-2020-29260

 -- luxinyou <luxinyou@uniontech.com>  Tue, 13 Dec 2022 18:05:51 +0100

libvncserver (0.9.11+dfsg-1.3.1+deepin) buster; urgency=medium

  * debian/patches: Add CVE patches cve-2020-25708, cve-2020-14400, cve-2020-14399, cve-2020-14397

 -- luxinyou <luxinyou@uniontech.com>  Fri, 09 Dec 2022 12:05:51 +0100

libvncserver (0.9.11+dfsg-1.3+deb10u2) buster; urgency=medium

  * Regression update.

  * debian/patches: Add use-after-free/{4,5,6}.patch. All cherry-picked from
    upstream. Resolves crashing of x11vnc when vncviewer connects. (Closes:
    #905786).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 08 Jan 2020 08:22:51 +0100

libvncserver (0.9.11+dfsg-1.3+deb10u1) buster; urgency=medium

  * CVE-2019-15681: rfbserver: don't leak stack memory to the remote. (Closes:
    #943793).
  * debian/patches:
    + Trivial patch rebasing.
    + Add 3 use-after-free patches. Resolve a freeze during connection closure and a
      segmentation fault on multi-threaded VNC servers. (Closes: #905786).
    + Add 0002-set-true-color-flag-to-1.patch. Fix connecting to VMware servers.
      (Closes: #880531).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 03 Dec 2019 09:18:57 +0100

libvncserver (0.9.11+dfsg-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * LibVNCClient: ignore server-sent cut text longer than 1MB (CVE-2018-20748)
    (Closes: #920941)
  * LibVNCClient: ignore server-sent reason strings longer than 1MB
    (CVE-2018-20748) (Closes: #920941)
  * LibVNCClient: fail on server-sent desktop name lengths longer than 1MB
    (CVE-2018-20748) (Closes: #920941)
  * LibVNCClient: remove now-useless cast (CVE-2018-20748) (Closes: #920941)
  * Error out in rfbProcessFileTransferReadBuffer if length can not be
    allocated (CVE-2018-20749) (Closes: #920941)
  * Limit lenght to INT_MAX bytes in rfbProcessFileTransferReadBuffer()
    (CVE-2018-20750) (Closes: #920941)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 30 Jan 2019 22:39:15 +0100

libvncserver (0.9.11+dfsg-1.2) unstable; urgency=high

  * Non-maintainer upload.
  * Fix multiple security vulnerabilities (Closes: #916941)
    - Use-after-free in file transfer extension allows for potential
      code execution (CVE-2018-15126)
    - Heap out-of-bounds write in
      rfbserver.c:rfbProcessFileTransferReadBuffer() allows for
      potential code execution (CVE-2018-15127)
    - Multiple heap out-of-bound writes in VNC client code
      (CVE-2018-20019)
    - Heap out-of-bound write inside structure in VNC client code allows
      for potential code execution (CVE-2018-20020)
    - Infinite loop in VNC client code allows for denial of service
      (CVE-2018-20021)
    - Improper initialization in VNC client code allows for information
      disclosure (CVE-2018-20022)
    - Improper initialization in VNC Repeater client code allows for
      information disclosure (CVE-2018-20023)
    - NULL pointer dereference in VNC client code allows for denial of
      service (CVE-2018-20024)
    - Use-after-free in file transfer extension server code allows for
      potential code execution (CVE-2018-6307)
  * Update symbols file for libvncserver1.
    The fix for CVE-2018-15126 removes CloseUndoneFileTransfer and
    introduces new CloseUndoneFileDownload and CloseUndoneFileUpload.

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 02 Jan 2019 16:26:53 +0100

libvncserver (0.9.11+dfsg-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2018-7225: Uninitialized and potentially sensitive data could be
    accessed by remote attackers because the msg.cct.length in rfbserver.c was
    not sanitized. (Closes: #894045)

 -- Markus Koschany <apo@debian.org>  Tue, 05 Jun 2018 14:43:47 +0200

## libvncserver 0.9.12%2Bdfsg

=== debian/changelog ===
libvncserver (0.9.12+dfsg-9ubuntu0.3) focal-security; urgency=medium

  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2020-25708.patch: fix possible divide-by-zero in
      libvncserver/rfbserver.c.
    - CVE-2020-25708

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 16 Nov 2020 09:32:16 -0300

libvncserver (0.9.12+dfsg-9ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: buffer overflow via a long socket filename
    - debian/patches/CVE-2019-20839.patch: Error out if the unix socket name
      would overflow in libvncclient/sockets.c.
    - CVE-2019-20839
  * SECURITY UPDATE: NULL pointer dereference in anonTLS mode
    - debian/patches/CVE-2020-14396.patch: Do not dereference NULL cred pointer
      in libvncclient/tls_openssl.c if in anonTLS mode.
    - CVE-2020-14396
  * SECURITY UPDATE: NULL pointer dereference in region clipping span routine
    - debian/patches/CVE-2020-14397.patch: Add NULL pointer dereference checks
      to libvncserver/rfbregion.c.
    - CVE-2020-14397
  * SECURITY UPDATE: infinite loop due to improperly closed TCP connection
    - debian/patches/CVE-2020-14398.patch: Close the connection after a certain
      number of retries in libvncclient/sockets.c.
    - CVE-2020-14398
  * SECURITY UPDATE: byte-aligned data is accessed through uint32_t pointers
    - debian/patches/CVE-2020-14399.patch: Ensure a proper stack alignment in
      libvncclient/rfbproto.c.
    - CVE-2020-14399
  * SECURITY UPDATE: byte-aligned data is accessed through uint16_t pointers 
    - debian/patches/CVE-2020-14400.patch: Ensure a proper stack alignment in
      libvncserver/translate.c.
    - CVE-2020-14400
  * SECURITY UPDATE: integer overflow in bitwise operation on pixel_value
    - debian/patches/CVE-2020-14401.patch: Cast variable to 64 bit before
      performing bitwise operation.
    - CVE-2020-14401
  * SECURITY UPDATE: out-of-bounds access via encodings
    - debian/patches/CVE-2020-14402_CVE-2020-14403_CVE-2020-14404.patch:
      Check bounds before accessing array value in libvncserver/corre.c,
      libvncserver/hextile.c and libvncserver/rre.c
    - CVE-2020-14402
    - CVE-2020-14403
    - CVE-2020-14404
  * SECURITY UPDATE: unchecked TextChat allocation size
    - debian/patches/CVE-2020-14405.patch: Limit max TextChat size in
      libvncclient/rfbproto.c.
    - CVE-2020-14405

 -- Avital Ostromich <avital.ostromich@canonical.com>  Fri, 10 Jul 2020 15:42:39 -0400

libvncserver (0.9.12+dfsg-9ubuntu0.1) focal; urgency=medium

  * SECURITY UPDATE: null pointer dereference in HandleZlibBPP function which
    results in DoS
    - debian/patches/CVE-2019-15680.patch: prevent dereferencing of null
      pointers during decoding in libvncclient/zlib.c and libvncclient/zrle.c.
    - CVE-2019-15680

 -- Avital Ostromich <avital.ostromich@canonical.com>  Wed, 22 Apr 2020 18:47:50 -0400

libvncserver (0.9.12+dfsg-9) unstable; urgency=medium

  * Bump Standards-Version: to 4.5.0. No changes needed.
  * debian/patches:
    + Add CVE-2019-15690/0001-heap-buffer-overflow.patch. (Closes: #954163).

 -- Antoni Villalonga <antoni@friki.cat>  Sat, 21 Mar 2020 12:51:24 +0100

libvncserver (0.9.12+dfsg-8) unstable; urgency=medium

  * debian/changelog:
    + Typo fix in previous upload stanza.
  * debian/patches:
    + Add 0005_LibVNCCient-fix-regression-in-tight-raw-decoding.patch.
      LibVNCClient: Fix regression in Tight/Raw decoding. (Closes: #950330).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 01 Feb 2020 23:05:21 +0100

libvncserver (0.9.12+dfsg-7) unstable; urgency=medium

  * debian/patches:
    + Add 0003_rfbserver-dont-close-fd-0-accidentally.patch and
      0004_avoid-pthread-join-if-backgroundLoop-is-FALSE.patch. Follow-up fixes
      for concurrency issue during client closure between client and
      clientOutput thread. (See #905786).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 08 Jan 2020 10:36:05 +0100

libvncserver (0.9.12+dfsg-6) unstable; urgency=medium

  [ Sebastien Bacher ]
  * debian/tests:
    + Use the correct compiler for proposed autopkgtest cross-testing support.
      (Closes: #946615).

  [ Mike Gabriel ]
  * debian/patches:
    + Add 0002_fix-crash-because-of-unaligned-accesses-in-hybiReadAndDecode.patch.
      Fix FTBFS on sparc64 architecture. (Closes: #947808).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 Jan 2020 15:04:42 +0100

libvncserver (0.9.12+dfsg-5) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/control:
    + Add Ds (libvncserver-dev): libgcrypt20-dev, liblzo2-dev and libsasl2-dev.
      (As found under B-D). (Closes: #946865).
  * debian/tests/control:
    + White-space cleanup.

  [ Antoni Villalonga ]
  * Add debian/.gitlab.yml salsa tests.

  [ Sebastien Bacher ]
  * debian/control:
    + Use the correct team name in the Vcs references

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 18 Dec 2019 09:51:48 +0100

libvncserver (0.9.12+dfsg-4) unstable; urgency=medium

  [ Antoni Villalonga ]
  * debian/control:
    + Remove obsolete D (libvncserver-dev): libvncserver-config. (Closes:
      #946598).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Dec 2019 21:58:16 +0100

libvncserver (0.9.12+dfsg-3) unstable; urgency=medium

  * Re-upload to unstable as-is.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Dec 2019 08:02:19 +0100

libvncserver (0.9.12+dfsg-2) experimental; urgency=medium

  * debian/changelog:
    + Weave-in NMU changelog stanzas from previous security uploads
      (0.9.11+dfsg-1.1 through to 0.9.11+dfsg-1.3).
  * debian/patches:
    + Use subdirs for CVE issues.
    + Re-add erroneously removed patch/fix for CVE-2018-20750.
    + Rebase patch/fix for CVE-2019-15681.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 29 Nov 2019 09:50:45 +0100

libvncserver (0.9.12+dfsg-1) experimental; urgency=medium

  * New upstream release to experimental. (Closes: #918777).
  * debian/{control,compat}:
    + Switch to debhelper-compat notation. Bump DH compat level to version 12.


## libvncserver 0.9.12+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
cmake_policy(SET CMP0037 NEW)

project(LibVNCServer)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckTypeSize)
include(TestBigEndian)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)

enable_testing()

set(PACKAGE_NAME           "LibVNCServer")
set(FULL_PACKAGE_NAME      "LibVNCServer")
set(VERSION_MAJOR          "0")
set(VERSION_MINOR          "9")
set(VERSION_PATCHLEVEL     "12")
set(VERSION_SO             "1")
set(PACKAGE_VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCHLEVEL}")
set(PROJECT_BUGREPORT_PATH "https://github.com/LibVNC/libvncserver/issues")
set(LIBVNCSERVER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libvncserver)
set(COMMON_DIR ${CMAKE_CURRENT_SOURCE_DIR}/common)
set(LIBVNCCLIENT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libvncclient)
set(LIBVNCSRVEXAMPLE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/examples)
set(LIBVNCCLIEXAMPLE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/client_examples)
set(TESTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")


include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libvncserver ${CMAKE_CURRENT_SOURCE_DIR}/common)

# all the build configuration switches
option(BUILD_SHARED_LIBS "Build shared libraries" ${UNIX})
option(WITH_ZLIB "Search for the zlib compression library to support additional encodings" ON)
option(WITH_LZO "Search for the LZO compression library to omit internal miniLZO implementation" ON)
option(WITH_JPEG "Search for the libjpeg compression library to support additional encodings" ON)
option(WITH_PNG "Search for the PNG compression library to support additional encodings" ON)
option(WITH_SDL "Search for the Simple Direct Media Layer library to build an example SDL vnc client" ON)
option(WITH_THREADS "Search for a threading library to build with multithreading support" ON)
option(WITH_GNUTLS "Search for the GnuTLS secure communications library to support encryption" ON)
option(WITH_OPENSSL "Search for the OpenSSL cryptography library to support encryption" ON)
option(WITH_SYSTEMD "Search for libsystemd to build with systemd socket activation support" ON)
option(WITH_GCRYPT "Search for libgcrypt to support additional authentication methods in LibVNCClient" ON)
option(WITH_FFMPEG "Search for FFMPEG to build an example VNC to MPEG encoder" ON)
option(WITH_TIGHTVNC_FILETRANSFER "Enable filetransfer if there is pthreads support" ON)
option(WITH_24BPP "Allow 24 bpp" ON)
option(WITH_IPv6 "Enable IPv6 Support" ON)
option(WITH_WEBSOCKETS "Build with websockets support" ON)
option(WITH_SASL "Build with SASL support" ON)



if(WITH_ZLIB)
  find_package(ZLIB)
endif(WITH_ZLIB)

if(WITH_LZO)
  find_package(LZO)
endif()

if(WITH_JPEG)
  find_package(JPEG)
  if(JPEG_FOUND)
    # Check whether the version of libjpeg we found was libjpeg-turbo and print a
    # warning if not.
    set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -I${JPEG_INCLUDE_DIR})

    set(JPEG_TEST_SOURCE "\n
    #include <stdio.h>\n
    #include <jpeglib.h>\n
    int main(void) {\n
      struct jpeg_compress_struct cinfo;\n
      struct jpeg_error_mgr jerr;\n
      cinfo.err=jpeg_std_error(&jerr);\n
      jpeg_create_compress(&cinfo);\n
      cinfo.input_components = 3;\n
      jpeg_set_defaults(&cinfo);\n
      cinfo.in_color_space = JCS_EXT_RGB;\n
      jpeg_default_colorspace(&cinfo);\n
      return 0;\n
    }")

    if(CMAKE_CROSSCOMPILING)
      check_c_source_compiles("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
    else()
      check_c_source_runs("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
    endif()

    set(CMAKE_REQUIRED_LIBRARIES)
    set(CMAKE_REQUIRED_FLAGS)
    set(CMAKE_REQUIRED_DEFINITIONS)

    if(NOT FOUND_LIBJPEG_TURBO)
      message(WARNING "*** The libjpeg library you are building against is not libjpeg-turbo.  Performance will be reduced.  You can obtain libjpeg-turbo from:  https://sourceforge.net/projects/libjpeg-turbo/files/ ***")
    endif()
  endif(JPEG_FOUND)
endif(WITH_JPEG)


if(WITH_PNG)
  find_package(PNG)
endif(WITH_PNG)


if(WITH_SDL)
  find_package(SDL2)
endif(WITH_SDL)


if(WITH_THREADS)
  find_package(Threads)
endif(WITH_THREADS)


if(WITH_GNUTLS)
  find_package(GnuTLS)
endif(WITH_GNUTLS)


if(WITH_OPENSSL)
  find_package(OpenSSL)
endif(WITH_OPENSSL)


if(WITH_SYSTEMD AND NOT ANDROID)
  find_package(PkgConfig)
  pkg_check_modules(SYSTEMD "libsystemd")
endif(WITH_SYSTEMD AND NOT ANDROID)


if(WITH_GCRYPT)
  find_library(LIBGCRYPT_LIBRARIES gcrypt)
endif(WITH_GCRYPT)

if(WITH_FFMPEG)
  find_package(FFMPEG 3.1.0)
endif(WITH_FFMPEG)


check_include_file("endian.h"      LIBVNCSERVER_HAVE_ENDIAN_H)
check_include_file("fcntl.h"       LIBVNCSERVER_HAVE_FCNTL_H)
check_include_file("netinet/in.h"  LIBVNCSERVER_HAVE_NETINET_IN_H)
check_include_file("sys/endian.h"  LIBVNCSERVER_HAVE_SYS_ENDIAN_H)
check_include_file("sys/socket.h"  LIBVNCSERVER_HAVE_SYS_SOCKET_H)
check_include_file("sys/stat.h"    LIBVNCSERVER_HAVE_SYS_STAT_H)
check_include_file("sys/time.h"    LIBVNCSERVER_HAVE_SYS_TIME_H)
check_include_file("sys/types.h"   LIBVNCSERVER_HAVE_SYS_TYPES_H)
check_include_file("sys/wait.h"    LIBVNCSERVER_HAVE_SYS_WAIT_H)
check_include_file("unistd.h"      LIBVNCSERVER_HAVE_UNISTD_H)
check_include_file("sys/uio.h"     LIBVNCSERVER_HAVE_SYS_UIO_H)


# headers needed for check_type_size()
check_include_file("vfork.h"       LIBVNCSERVER_HAVE_VFORK_H)
check_include_file("ws2tcpip.h"    LIBVNCSERVER_HAVE_WS2TCPIP_H)
check_include_file("arpa/inet.h"   HAVE_ARPA_INET_H)
check_include_file("stdint.h"      HAVE_STDINT_H)
check_include_file("stddef.h"      HAVE_STDDEF_H)
check_include_file("sys/types.h"   HAVE_SYS_TYPES_H)

# error out if required headers not found
if(NOT HAVE_STDINT_H)
  message(FATAL_ERROR "Could NOT find required header stdint.h")
endif()

check_function_exists(gettimeofday    LIBVNCSERVER_HAVE_GETTIMEOFDAY)
check_function_exists(vfork           LIBVNCSERVER_HAVE_VFORK)
check_function_exists(vprintf         LIBVNCSERVER_HAVE_VPRINTF)
check_function_exists(mmap            LIBVNCSERVER_HAVE_MMAP)
check_function_exists(fork            LIBVNCSERVER_HAVE_FORK)
check_function_exists(ftime           LIBVNCSERVER_HAVE_FTIME)
check_function_exists(gethostbyname   LIBVNCSERVER_HAVE_GETHOSTBYNAME)
check_function_exists(gethostname     LIBVNCSERVER_HAVE_GETHOSTNAME)
check_function_exists(inet_ntoa       LIBVNCSERVER_HAVE_INET_NTOA)
check_function_exists(memmove         LIBVNCSERVER_HAVE_MEMMOVE)
check_function_exists(memset          LIBVNCSERVER_HAVE_MEMSET)
check_function_exists(mkfifo          LIBVNCSERVER_HAVE_MKFIFO)
check_function_exists(select          LIBVNCSERVER_HAVE_SELECT)
check_function_exists(socket          LIBVNCSERVER_HAVE_SOCKET)
check_function_exists(strchr          LIBVNCSERVER_HAVE_STRCHR)
check_function_exists(strcspn         LIBVNCSERVER_HAVE_STRCSPN)
check_function_exists(strdup          LIBVNCSERVER_HAVE_STRDUP)
check_function_exists(strerror        LIBVNCSERVER_HAVE_STRERROR)
check_function_exists(strstr          LIBVNCSERVER_HAVE_STRSTR)

check_symbol_exists(htobe64 "endian.h" LIBVNCSERVER_HAVE_HTOBE64)
check_symbol_exists(OSSwapHostToBigInt64 "libkern/OSByteOrder.h" LIBVNCSERVER_HAVE_OSSWAPHOSTTOBIGINT64)

if(Threads_FOUND)
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
endif(Threads_FOUND)
if(ZLIB_FOUND)
  set(LIBVNCSERVER_HAVE_LIBZ 1)
else()
  unset(ZLIB_LIBRARIES) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif(ZLIB_FOUND)
if(LZO_FOUND)
  set(LIBVNCSERVER_HAVE_LZO 1)
else()
  unset(LZO_LIBRARIES CACHE) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif()
if(JPEG_FOUND)
  set(LIBVNCSERVER_HAVE_LIBJPEG 1)
else()
  unset(JPEG_LIBRARIES) # would otherwise confuse target_link_libraries()
endif(JPEG_FOUND)
if(PNG_FOUND)
  set(LIBVNCSERVER_HAVE_LIBPNG 1)
endif(PNG_FOUND)
if(NOT OPENSSL_FOUND)
    unset(OPENSSL_LIBRARIES) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif()
if(SYSTEMD_FOUND)
  add_definitions(-DLIBVNCSERVER_WITH_SYSTEMD)
  include_directories(${SYSTEMD_INCLUDE_DIRS})
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${SYSTEMD_LIBRARIES})
endif(SYSTEMD_FOUND)

if(LIBVNCSERVER_HAVE_SYS_UIO_H)
  if(GNUTLS_FOUND)
    message(STATUS "Building crypto with GnuTLS")
    set(CRYPTO_LIBRARIES ${GNUTLS_LIBRARIES})
    set(CRYPTO_SOURCES ${COMMON_DIR}/rfbcrypto_gnutls)
    include_directories(${GNUTLS_INCLUDE_DIR})
  elseif(OPENSSL_FOUND)
    message(STATUS "Building crypto with OpenSSL")
    set(CRYPTO_LIBRARIES ${OPENSSL_LIBRARIES})
    set(CRYPTO_SOURCES ${COMMON_DIR}/rfbcrypto_openssl)
  else()
    message(STATUS "Building crypto with builtin functions")
    set(CRYPTO_SOURCES ${COMMON_DIR}/rfbcrypto_included.c ${COMMON_DIR}/md5.c ${COMMON_DIR}/sha1.c)
  endif()
  set(LIBVNCSERVER_HAVE_CRYPTO 1)
endif(LIBVNCSERVER_HAVE_SYS_UIO_H)


if(WITH_WEBSOCKETS AND LIBVNCSERVER_HAVE_CRYPTO AND (LIBVNCSERVER_HAVE_HTOBE64 OR LIBVNCSERVER_HAVE_OSSWAPHOSTTOBIGINT64))
  set(LIBVNCSERVER_WITH_WEBSOCKETS 1)
endif()

if(WITH_GCRYPT AND LIBGCRYPT_LIBRARIES)
  message(STATUS "Found libgcrypt: ${LIBGCRYPT_LIBRARIES}")
  set(LIBVNCSERVER_WITH_CLIENT_GCRYPT 1)
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${LIBGCRYPT_LIBRARIES})
endif(WITH_GCRYPT AND LIBGCRYPT_LIBRARIES)

if(GNUTLS_FOUND)
  set(LIBVNCSERVER_HAVE_GNUTLS 1)
endif(GNUTLS_FOUND)

if(OPENSSL_FOUND)
  set(LIBVNCSERVER_HAVE_LIBSSL 1)
endif(OPENSSL_FOUND)

if(WITH_IPv6)
  if(WIN32 AND LIBVNCSERVER_HAVE_WS2TCPIP_H AND LIBVNCSERVER_HAVE_VPRINTF)
    set(LIBVNCSERVER_IPv6 1)
  endif()
  if(NOT WIN32)
    set(LIBVNCSERVER_IPv6 1)
  endif()
endif(WITH_IPv6)


if(WITH_24BPP)
  set(LIBVNCSERVER_ALLOW24BPP 1)
endif()


if(CMAKE_USE_PTHREADS_INIT)
  set(LIBVNCSERVER_HAVE_LIBPTHREAD 1)
endif(CMAKE_USE_PTHREADS_INIT)
if(LIBVNCSERVER_HAVE_SYS_SOCKET_H)
  # socklen_t
  list(APPEND CMAKE_EXTRA_INCLUDE_FILES "sys/socket.h")
endif(LIBVNCSERVER_HAVE_SYS_SOCKET_H)
if(HAVE_ARPA_INET_H)
  # in_addr_t
  list(APPEND CMAKE_EXTRA_INCLUDE_FILES "arpa/inet.h")
endif(HAVE_ARPA_INET_H)

check_type_size(pid_t     LIBVNCSERVER_PID_T)
check_type_size(size_t    LIBVNCSERVER_SIZE_T)
check_type_size(socklen_t LIBVNCSERVER_SOCKLEN_T)
check_type_size(in_addr_t LIBVNCSERVER_IN_ADDR_T)
if(NOT HAVE_LIBVNCSERVER_IN_ADDR_T)
  set(LIBVNCSERVER_NEED_INADDR_T 1)
endif(NOT HAVE_LIBVNCSERVER_IN_ADDR_T)

TEST_BIG_ENDIAN(LIBVNCSERVER_WORDS_BIGENDIAN)

if(WITH_SASL)
  find_path(SASL2_INCLUDE_DIR sasl/sasl.h)
  find_library(LIBSASL2_LIBRARIES sasl2 libsasl.lib)
endif(WITH_SASL)

if(WITH_SASL AND LIBSASL2_LIBRARIES AND SASL2_INCLUDE_DIR)
  message(STATUS "Building with SASL: ${LIBSASL2_LIBRARIES} and ${SASL2_INCLUDE_DIR}")
  set(LIBVNCSERVER_HAVE_SASL 1)
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${LIBSASL2_LIBRARIES})
  include_directories(${SASL2_INCLUDE_DIR})
endif(WITH_SASL AND LIBSASL2_LIBRARIES AND SASL2_INCLUDE_DIR)

# TODO:
# LIBVNCSERVER_ENOENT_WORKAROUND
# inline

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/rfb/rfbconfig.h.cmakein ${CMAKE_BINARY_DIR}/rfb/rfbconfig.h)

set(LIBVNCSERVER_SOURCES
    ${LIBVNCSERVER_DIR}/main.c
    ${LIBVNCSERVER_DIR}/rfbserver.c
    ${LIBVNCSERVER_DIR}/rfbregion.c
    ${LIBVNCSERVER_DIR}/auth.c
    ${LIBVNCSERVER_DIR}/sockets.c
    ${LIBVNCSERVER_DIR}/stats.c
    ${LIBVNCSERVER_DIR}/corre.c
    ${LIBVNCSERVER_DIR}/hextile.c
    ${LIBVNCSERVER_DIR}/rre.c
    ${LIBVNCSERVER_DIR}/translate.c
    ${LIBVNCSERVER_DIR}/cutpaste.c
    ${LIBVNCSERVER_DIR}/httpd.c
    ${LIBVNCSERVER_DIR}/cursor.c
    ${LIBVNCSERVER_DIR}/font.c
    ${LIBVNCSERVER_DIR}/draw.c
    ${LIBVNCSERVER_DIR}/selbox.c
    ${COMMON_DIR}/d3des.c
    ${COMMON_DIR}/vncauth.c
    ${LIBVNCSERVER_DIR}/cargs.c
    ${LIBVNCSERVER_DIR}/ultra.c
    ${LIBVNCSERVER_DIR}/scale.c
)

set(LIBVNCCLIENT_SOURCES
    ${LIBVNCCLIENT_DIR}/cursor.c
    ${LIBVNCCLIENT_DIR}/listen.c
    ${LIBVNCCLIENT_DIR}/rfbproto.c

=== debian/control ===
Source: libvncserver
Section: libs
Priority: optional
Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake (>= 3.4),
               debhelper-compat (= 12),
               libgnutls28-dev,
               libjpeg-dev,
               liblzo2-dev,
               pkg-config,
               libgcrypt20-dev,
               libsasl2-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://libvnc.github.io
Vcs-Git: https://salsa.debian.org/debian-remote-team/libvncserver.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/libvncserver/

Package: libvncclient1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libvncserver0 (<< 0.9.9+dfsg-3)
Replaces: libvncserver0 (<< 0.9.9+dfsg-3)
Multi-Arch: same
Description: API to write one's own VNC server - client library
 LibVNCServer makes writing a VNC server (or more correctly, a program
 exporting a framebuffer via the Remote Frame Buffer protocol) easy. It hides
 the programmer from the tedious task of managing clients and compression.
 .
 This package provides the client library.

Package: libvncserver1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: API to write one's own VNC server
 LibVNCServer makes writing a VNC server (or more correctly, a program
 exporting a framebuffer via the Remote Frame Buffer protocol) easy. It hides
 the programmer from the tedious task of managing clients and compression.
 .
 This package provides the server library.

Package: libvncserver-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libvncclient1 (= ${binary:Version}),
         libvncserver1 (= ${binary:Version}),
         libgcrypt20-dev,
         libgnutls28-dev,
         libjpeg-dev,
         liblzo2-dev,
         libsasl2-dev,
         zlib1g-dev,
Multi-Arch: same
Description: API to write one's own VNC server - development files
 LibVNCServer makes writing a VNC server (or more correctly, a program
 exporting a framebuffer via the Remote Frame Buffer protocol) easy. It hides
 the programmer from the tedious task of managing clients and compression.
 .
 This is the development package which contains headers and static libraries
 for libvncserver.

## libvncserver 0.9.13%2Bdfsg

=== debian/changelog ===
libvncserver (0.9.13+dfsg-2+deb11u1) bullseye; urgency=medium

  [ Mike Gabriel ]
  * debian/patches:
    + Trivially rebase patches 0001 and 0002.
    + Add 0003-rfb-increase-update-buf-size.patch. Allow larger screen sizes.
      (Closes: #1010449).

  [ Thorsten Alteholz ]
    + CVE-2020-29260: Add CVE-2020-29260.patch. Resolve memory leak in function
      rfbClientCleanup(). (Closes: #1019228).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 20 Nov 2022 13:18:12 +0100

libvncserver (0.9.13+dfsg-2) unstable; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * debian/patches:
    + Fix crashes when using desktop sharing with gnome-remote-desktop
      (LP: #1915410; closes: #982940).

  [ Mike Gabriel ]
  * debian/patches/series:
    + White-space cleanup.
  * debian/control:
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/watch:
    + Switch to format version 4.
  * debian/copyright:
    + Amend attributions. The files common/md5.* don't exist anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 28 Feb 2021 15:37:06 +0100

libvncserver (0.9.13+dfsg-1) unstable; urgency=medium

  * New upstream release:
    - CVE-2018-21247: When connecting to a repeater, only send initialised
      string
    - CVE-2019-20839: libvncclient: bail out if unix socket name would overflow
    - CVE-2019-20840: fix crash because of unaligned accesses in
      hybiReadAndDecode()
    - CVE-2020-14396: libvncclient/tls_openssl: do not deref a NULL pointer
    - CVE-2020-14397: libvncserver: add missing NULL pointer checks
    - CVE-2020-14398: libvncclient: handle half-open TCP connections
    - CVE-2020-14399: libvncclient: fix pointer aliasing/alignment issue
    - CVE-2020-14400: libvncserver: fix pointer aliasing/alignment issue
    - CVE-2020-14401: libvncserver: scale: cast to 64 bit before shifting
    - CVE-2020-14402: libvncserver: encodings: prevent OOB accesses
    - CVE-2020-14403: encodings: prevent OOB accesses
    - CVE-2020-14404: libvncserver: encodings: prevent OOB accesses
    - CVE-2020-14405: libvncclient/rfbproto: limit max textchat size
  * debian/patches:
    + Drop all patches. All applied upstream.
    + Add README file explaining on our patch naming scheme.
  * debian/*.symbols:
    + Update symbols.
  * debian/control:
    + Bump DH compat level to version 13.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 29 Jun 2020 14:44:43 +0200

## libvncserver 0.9.13+dfsg

=== debian/changelog ===
libvncserver (0.9.13+dfsg-3build2) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:14:48 +0100

libvncserver (0.9.13+dfsg-3build1) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:19:13 +0200

libvncserver (0.9.13+dfsg-3) unstable; urgency=medium

  * debian/watch:
    + Fix Github watch URL.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 29 Apr 2021 14:22:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libvncserver
 Section: libs
 Priority: optional
-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake (>= 3.4),
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libgnutls28-dev,
                libjpeg-dev,
                liblzo2-dev,
@@ -13,7 +14,7 @@
                libgcrypt20-dev,
                libsasl2-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://libvnc.github.io
 Vcs-Git: https://salsa.debian.org/debian-remote-team/libvncserver.git

=== debian/rules ===
#!/usr/bin/make -f

NULL =

VERSION = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//')

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ $(EXTRA_DH_ARG)

override_dh_auto_clean:
	dh_auto_clean
	rm -f rfb/rfbconfig.h

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DWITH_PNG=OFF \
	    -DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
	    $(NULL)


override_dh_strip:
	dh_strip -plibvncclient1 --dbgsym-migration='libvncclient1-dbg (<< 0.9.12-1~)'
	dh_strip -plibvncserver1 --dbgsym-migration='libvncserver1-dbg (<< 0.9.12-1~)'

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg// \
https://github.com/LibVNC/libvncserver/releases .*/archive/refs/tags/LibVNCServer-(\d\S+)\.tar\.gz

## libvncserver 0.9.14%2Bdfsg

=== debian/changelog ===
libvncserver (0.9.14+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:01:54 +0000

libvncserver (0.9.14+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:08:52 +0000

libvncserver (0.9.14+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/patches:
    + Drop all patches. All included in this upstream release.
  * debian/libvncserver-dev.install:
    + Add CMake module for LibVNCServer.
  * debian/*.symbols:
    + Update symbols for 0.9.14.
  * debian/{rules,source/lintian-overrides}:
    + Drop finished dbgsym-migration specific rules.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 17:38:46 +0100

libvncserver (0.9.13+dfsg-5) unstable; urgency=medium

  [ Thosten Alteholz ]
  * debian/patches:
    + CVE-2020-29260: Add CVE-2020-29260.patch. Resolve memory leak in
      function rfbClientCleanup(). (Closes: #1019228).

  [ Mike Gabriel ]
  * debian/watch:
    + Use tags-path on Github, not releases-path.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 20 Nov 2022 13:10:45 +0100

libvncserver (0.9.13+dfsg-4) unstable; urgency=medium

  * debian/patches:
    + Trivially rebase patches 0001 and 0002.
    + Add 0003-rfb-increase-update-buf-size.patch. Allow larger screen sizes.
      (Closes: #1010449).
  * debian/control:
    + Bump Standards-Version: to 4.6.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Jun 2022 09:47:24 +0200

## libvncserver 0.9.14+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(LibVNCServer VERSION 0.9.14 LANGUAGES C)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckTypeSize)
include(TestBigEndian)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(GNUInstallDirs)

enable_testing()

set(PACKAGE_NAME           "LibVNCServer")
set(FULL_PACKAGE_NAME      "LibVNCServer")
set(VERSION_SO             "1")
set(PROJECT_BUGREPORT_PATH "https://github.com/LibVNC/libvncserver/issues")
set(LIBVNCSERVER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libvncserver)
set(COMMON_DIR ${CMAKE_CURRENT_SOURCE_DIR}/common)
set(LIBVNCCLIENT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libvncclient)
set(LIBVNCSRVEXAMPLE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/examples)
set(LIBVNCCLIEXAMPLE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/client_examples)
set(TESTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
if(CMAKE_GENERATOR MATCHES "Unix Makefiles|Ninja")
# some LSP servers expect compile_commands.json in the project root
add_custom_target(
    copy-compile-commands ALL
    ${CMAKE_COMMAND} -E copy_if_different
        ${CMAKE_BINARY_DIR}/compile_commands.json
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
endif(CMAKE_GENERATOR MATCHES "Unix Makefiles|Ninja")

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libvncserver ${CMAKE_CURRENT_SOURCE_DIR}/common)

# all the build configuration switches
option(LIBVNCSERVER_INSTALL "Generate installation target" ON)
option(BUILD_SHARED_LIBS "Build shared libraries" ${UNIX})
option(WITH_ZLIB "Search for the zlib compression library to support additional encodings" ON)
option(WITH_LZO "Search for the LZO compression library to omit internal miniLZO implementation" ON)
option(WITH_JPEG "Search for the libjpeg compression library to support additional encodings" ON)
option(WITH_PNG "Search for the PNG compression library to support additional encodings" ON)
option(WITH_SDL "Search for the Simple Direct Media Layer library to build an example SDL vnc client" ON)
option(WITH_GTK "Search for the GTK library to build an example GTK vnc client" ON)
option(WITH_LIBSSH2 "Search for libssh2 to build an example ssh-tunneled client" ON)
option(WITH_THREADS "Search for a threading library to build with multithreading support" ON)
option(PREFER_WIN32THREADS "When searching for a threading library, prefer win32 threads if they are found" OFF)
option(WITH_GNUTLS "Search for the GnuTLS secure communications library to support TLS" ON)
option(WITH_OPENSSL "Search for the OpenSSL cryptography library to support TLS and use as crypto backend" ON)
option(WITH_SYSTEMD "Search for libsystemd to build with systemd socket activation support" ON)
option(WITH_GCRYPT "Search for Libgcrypt to use as crypto backend" ON)
option(WITH_FFMPEG "Search for FFMPEG to build an example VNC to MPEG encoder" ON)
option(WITH_TIGHTVNC_FILETRANSFER "Enable filetransfer if there is pthreads support" ON)
option(WITH_24BPP "Allow 24 bpp" ON)
option(WITH_IPv6 "Enable IPv6 Support" ON)
option(WITH_WEBSOCKETS "Build with websockets support" ON)
option(WITH_SASL "Build with SASL support" ON)
option(WITH_EXAMPLES "Build examples" ON)
option(WITH_TESTS "Build tests" ON)



if(WITH_ZLIB)
  find_package(ZLIB)
endif(WITH_ZLIB)

if(WITH_LZO)
  find_package(LZO)
endif()

if(WITH_JPEG)
  find_package(JPEG)
  if(JPEG_FOUND)
    # Check whether the version of libjpeg we found was libjpeg-turbo and print a
    # warning if not.
    set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})
    if(JPEG_INCLUDE_DIRS) # this was not present in 3.4
      set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIRS})
    else()
      set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
    endif()

    set(JPEG_TEST_SOURCE "\n
    #include <stdio.h>\n
    #include <jpeglib.h>\n
    int main(void) {\n
      struct jpeg_compress_struct cinfo;\n
      struct jpeg_error_mgr jerr;\n
      cinfo.err=jpeg_std_error(&jerr);\n
      jpeg_create_compress(&cinfo);\n
      cinfo.input_components = 3;\n
      jpeg_set_defaults(&cinfo);\n
      cinfo.in_color_space = JCS_EXT_RGB;\n
      jpeg_default_colorspace(&cinfo);\n
      return 0;\n
    }")

    if(CMAKE_CROSSCOMPILING)
      check_c_source_compiles("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
    else()
      check_c_source_runs("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
    endif()

    set(CMAKE_REQUIRED_LIBRARIES)
    set(CMAKE_REQUIRED_INCLUDES)
    set(CMAKE_REQUIRED_DEFINITIONS)

    if(NOT FOUND_LIBJPEG_TURBO)
      # last-resort grep check (when using LibVNCServer as a CMake subdir together with turbojpeg CMake subdir, the build check above fails since turbojpeg is not yet built when LibVNCServer is configured)
      get_filename_component(JPEGLIB_H_PATH "${JPEG_INCLUDE_DIR}/jpeglib.h" REALPATH BASE_DIR "${CMAKE_SOURCE_DIR}")
      message(STATUS "Runtime check for libjpeg-turbo failed, inspecting ${JPEGLIB_H_PATH}")
      file(STRINGS ${JPEGLIB_H_PATH} FOUND_LIBJPEG_TURBO REGEX "JCS_EXT_RGB")
      if(NOT FOUND_LIBJPEG_TURBO)
	message(WARNING "*** The libjpeg library you are building against is not libjpeg-turbo.  Performance will be reduced.  You can obtain libjpeg-turbo from:  https://sourceforge.net/projects/libjpeg-turbo/files/ ***")
      endif()
    endif()
  endif(JPEG_FOUND)
endif(WITH_JPEG)


if(WITH_PNG)
  find_package(PNG)
endif(WITH_PNG)


if(WITH_SDL)
  find_package(SDL2)
endif(WITH_SDL)

if(WITH_GTK)
  find_package(GTK2)
endif(WITH_GTK)

if(WITH_LIBSSH2)
  find_package(LibSSH2)
endif(WITH_LIBSSH2)

if(WITH_THREADS)
  find_package(Threads)
endif(WITH_THREADS)


if(WITH_GNUTLS)
  find_package(GnuTLS 3.4.0)
endif(WITH_GNUTLS)


if(WITH_OPENSSL)
  find_package(OpenSSL)
endif(WITH_OPENSSL)


if(WITH_SYSTEMD AND NOT ANDROID AND NOT WIN32)
  find_package(PkgConfig)
  pkg_check_modules(SYSTEMD "libsystemd")
endif(WITH_SYSTEMD AND NOT ANDROID AND NOT WIN32)


if(WITH_GCRYPT)
  find_library(LIBGCRYPT_LIBRARIES gcrypt)
endif(WITH_GCRYPT)

if(WITH_FFMPEG)
  find_package(FFMPEG 3.1.0 COMPONENTS avformat avcodec avutil swscale)
endif(WITH_FFMPEG)


check_include_file("dirent.h"      LIBVNCSERVER_HAVE_DIRENT_H)
check_include_file("endian.h"      LIBVNCSERVER_HAVE_ENDIAN_H)
check_include_file("fcntl.h"       LIBVNCSERVER_HAVE_FCNTL_H)
check_include_file("netinet/in.h"  LIBVNCSERVER_HAVE_NETINET_IN_H)
check_include_file("sys/endian.h"  LIBVNCSERVER_HAVE_SYS_ENDIAN_H)
check_include_file("sys/socket.h"  LIBVNCSERVER_HAVE_SYS_SOCKET_H)
check_include_file("sys/stat.h"    LIBVNCSERVER_HAVE_SYS_STAT_H)
check_include_file("sys/time.h"    LIBVNCSERVER_HAVE_SYS_TIME_H)
check_include_file("sys/types.h"   LIBVNCSERVER_HAVE_SYS_TYPES_H)
check_include_file("sys/wait.h"    LIBVNCSERVER_HAVE_SYS_WAIT_H)
check_include_file("unistd.h"      LIBVNCSERVER_HAVE_UNISTD_H)
check_include_file("sys/resource.h"     LIBVNCSERVER_HAVE_SYS_RESOURCE_H)


# headers needed for check_type_size()
check_include_file("vfork.h"       LIBVNCSERVER_HAVE_VFORK_H)
check_include_file("ws2tcpip.h"    LIBVNCSERVER_HAVE_WS2TCPIP_H)
check_include_file("arpa/inet.h"   HAVE_ARPA_INET_H)
check_include_file("stdint.h"      HAVE_STDINT_H)
check_include_file("stddef.h"      HAVE_STDDEF_H)
check_include_file("sys/types.h"   HAVE_SYS_TYPES_H)

# error out if required headers not found
if(NOT HAVE_STDINT_H)
  message(FATAL_ERROR "Could NOT find required header stdint.h")
endif()

check_function_exists(gettimeofday    LIBVNCSERVER_HAVE_GETTIMEOFDAY)
check_function_exists(vfork           LIBVNCSERVER_HAVE_VFORK)
check_function_exists(vprintf         LIBVNCSERVER_HAVE_VPRINTF)
check_function_exists(mmap            LIBVNCSERVER_HAVE_MMAP)
check_function_exists(fork            LIBVNCSERVER_HAVE_FORK)
check_function_exists(ftime           LIBVNCSERVER_HAVE_FTIME)
check_function_exists(gethostbyname   LIBVNCSERVER_HAVE_GETHOSTBYNAME)
check_function_exists(gethostname     LIBVNCSERVER_HAVE_GETHOSTNAME)
check_function_exists(inet_ntoa       LIBVNCSERVER_HAVE_INET_NTOA)
check_function_exists(memmove         LIBVNCSERVER_HAVE_MEMMOVE)
check_function_exists(memset          LIBVNCSERVER_HAVE_MEMSET)
check_function_exists(mkfifo          LIBVNCSERVER_HAVE_MKFIFO)
check_function_exists(select          LIBVNCSERVER_HAVE_SELECT)
check_function_exists(socket          LIBVNCSERVER_HAVE_SOCKET)
check_function_exists(strchr          LIBVNCSERVER_HAVE_STRCHR)
check_function_exists(strcspn         LIBVNCSERVER_HAVE_STRCSPN)
check_function_exists(strdup          LIBVNCSERVER_HAVE_STRDUP)
check_function_exists(strerror        LIBVNCSERVER_HAVE_STRERROR)
check_function_exists(strstr          LIBVNCSERVER_HAVE_STRSTR)

check_symbol_exists(htobe64 "endian.h" LIBVNCSERVER_HAVE_HTOBE64)
check_symbol_exists(htobe64 "sys/endian.h" LIBVNCSERVER_HAVE_HTOBE64)
check_symbol_exists(OSSwapHostToBigInt64 "libkern/OSByteOrder.h" LIBVNCSERVER_HAVE_OSSWAPHOSTTOBIGINT64)

if(WITH_THREADS AND Threads_FOUND)
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
endif(WITH_THREADS AND Threads_FOUND)
if(ZLIB_FOUND)
  set(LIBVNCSERVER_HAVE_LIBZ 1)
else()
  unset(ZLIB_LIBRARIES) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif(ZLIB_FOUND)
if(LZO_FOUND)
  set(LIBVNCSERVER_HAVE_LZO 1)
else()
  unset(LZO_LIBRARIES CACHE) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif()
if(JPEG_FOUND)
  set(LIBVNCSERVER_HAVE_LIBJPEG 1)
else()
  unset(JPEG_LIBRARIES) # would otherwise confuse target_link_libraries()
endif(JPEG_FOUND)
if(PNG_FOUND)
  set(LIBVNCSERVER_HAVE_LIBPNG 1)
else()
  unset(PNG_LIBRARIES) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif(PNG_FOUND)
if(NOT OPENSSL_FOUND)
    unset(OPENSSL_LIBRARIES) # would otherwise contain -NOTFOUND, confusing target_link_libraries()
endif()
if(SYSTEMD_FOUND)
  add_definitions(-DLIBVNCSERVER_WITH_SYSTEMD)
  include_directories(${SYSTEMD_INCLUDE_DIRS})
  set(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} ${SYSTEMD_LIBRARIES})
endif(SYSTEMD_FOUND)

# common crypto used by both libvncserver and libvncclient
if(WITH_GCRYPT AND LIBGCRYPT_LIBRARIES)
  message(STATUS "Building crypto with Libgcrypt")
  set(CRYPTO_LIBRARIES ${LIBGCRYPT_LIBRARIES})
  set(CRYPTO_SOURCES ${COMMON_DIR}/crypto_libgcrypt.c)
elseif(OPENSSL_FOUND)
  message(STATUS "Building crypto with OpenSSL")
  set(CRYPTO_LIBRARIES ${OPENSSL_LIBRARIES})
  set(CRYPTO_SOURCES ${COMMON_DIR}/crypto_openssl.c)
else()
  message(STATUS "Building crypto with builtin functions, only including SHA1 and D3DES")
  set(CRYPTO_SOURCES ${COMMON_DIR}/crypto_included.c ${COMMON_DIR}/sha1.c ${COMMON_DIR}/d3des.c)
endif()

if(WITH_WEBSOCKETS AND (LIBVNCSERVER_HAVE_HTOBE64 OR LIBVNCSERVER_HAVE_OSSWAPHOSTTOBIGINT64))
  set(LIBVNCSERVER_WITH_WEBSOCKETS 1)
endif()

if(WITH_GCRYPT AND LIBGCRYPT_LIBRARIES)
  set(LIBVNCSERVER_HAVE_LIBGCRYPT 1)
endif(WITH_GCRYPT AND LIBGCRYPT_LIBRARIES)

if(GNUTLS_FOUND)
  set(LIBVNCSERVER_HAVE_GNUTLS 1)
endif(GNUTLS_FOUND)

if(OPENSSL_FOUND)
  include_directories(${OPENSSL_INCLUDE_DIR})
  set(LIBVNCSERVER_HAVE_LIBSSL 1)
endif(OPENSSL_FOUND)

if(WITH_IPv6)
  if(WIN32 AND LIBVNCSERVER_HAVE_WS2TCPIP_H AND LIBVNCSERVER_HAVE_VPRINTF)
    set(LIBVNCSERVER_IPv6 1)
  endif()
  if(NOT WIN32)
    set(LIBVNCSERVER_IPv6 1)
  endif()
endif(WITH_IPv6)


if(WITH_24BPP)
  set(LIBVNCSERVER_ALLOW24BPP 1)
endif()

# Make sure that only one threading system is used. This happens on MinGW.
if(WITH_THREADS)
  if(CMAKE_USE_PTHREADS_INIT AND CMAKE_USE_WIN32_THREADS_INIT)
    if(PREFER_WIN32THREADS)
      unset(CMAKE_USE_PTHREADS_INIT)
    else()
      unset(CMAKE_USE_WIN32_THREADS_INIT)
    endif(PREFER_WIN32THREADS)
  endif(CMAKE_USE_PTHREADS_INIT AND CMAKE_USE_WIN32_THREADS_INIT)

  if(CMAKE_USE_PTHREADS_INIT)
    set(LIBVNCSERVER_HAVE_LIBPTHREAD 1)
    message(STATUS "Threads support is using pthreads")
  endif(CMAKE_USE_PTHREADS_INIT)

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libvncserver
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
+Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake (>= 3.4),
@@ -14,7 +13,7 @@
                libgcrypt20-dev,
                libsasl2-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://libvnc.github.io
 Vcs-Git: https://salsa.debian.org/debian-remote-team/libvncserver.git
